﻿using AspNetCoreLecture.DAL.EFCore;
using AspNetCoreLecture.DAL.EFCore.Entities;
using AspNetCoreLecture.Data.Dto;
using Mapster;
using Microsoft.EntityFrameworkCore;

namespace AspNetCoreLecture.Data.Repository
{
    public class GradeRepository : RepositoryBase<Grade, GradeDto>, IGradeRepository
    {
        private readonly SchoolDbContext _dbContext;

        public GradeRepository(SchoolDbContext dbContext) : base(dbContext)
        {
            _dbContext = dbContext;
        }

        public IEnumerable<GradeDto> GetAllForStudent(int studentId)
        {
            return _dbContext.Grades
                .AsNoTracking()
                .Where(x => x.StudentId == studentId)
                .AsEnumerable()
                .Select(x => x.Adapt<GradeDto>())
                .ToArray();
        }
    }
}
